///home/berryj/link/bin/genMethods "-g" "-t" "Set<char*>" "-h" "Collection" "-I" "LINK/basic/Set.h" "-I" "LINK/basic/SetFuncs.h" "-I" "LINK/basic/Collection.h" "-d" "basic" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/Set.h>

#include <LINK/basic/SetFuncs.h>

#include <LINK/basic/Collection.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/CollectionWrapper.h>


typedef Set<char*> _Set_char__;
typedef Collection<Set<char*> > _Collection_Set_char___;

#define _Collection_Set_char___DATA(x) ((Collection<Set<char*> >*) (EXTDATA(x)))
#define _Collection_Set_char___IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Collection<Set<char*> > >::type))
#define _Collection_Set_char___ISNT_DATA(x) (!_Collection_Set_char___IS_DATA(x))

#define _Collection_Set_char___CXX_DATA(x) (*(Collection<Set<char*> >*) (EXTDATA(VAL(x))))
#define _Collection_Set_char___CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Collection<Set<char*> > >::type))
#define _Collection_Set_char___CXX_ISNT_DATA(x) (!_Collection_Set_char___CXX_IS_DATA(x))


PRIMITIVE STk_init__Collection_Set_char___()
{
	Wrapper<_Collection_Set_char___>::type = STk_new_CXXwrapper_id(
			Wrapper<_Collection_Set_char___>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			CollectionWrapper<_Set_char__>::displayTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Set_char__>::markTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Set_char__>::freeTypedCollection);
	Tcl_InitHashTable(&Register<_Collection_Set_char___>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_Collection_Set_char___Methods(void);

PRIMITIVE STk_init_methods__Collection_Set_char___()
{
	STk_add_new_cpp_primitive("collection-Set-char?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::collectionP);
	STk_add_new_cpp_primitive("mset-Set-char1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::buildMSet);
	STk_add_new_cpp_primitive("set-Set-char1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::buildSet);
	STk_add_new_cpp_primitive("sequence-Set-char1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::buildSequence);
	STk_add_new_cpp_primitive("Collection-Set-char-sorted?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::sortedLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-char-size", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::sizeLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-char-null?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::nullLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-char-eqv?", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::eqvLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-char-<", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::lthLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-char-<=", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::leLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-char->", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::grLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-char->=", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::geLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-char-member", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::memberLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-char-clear!", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::clearLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-char-insert!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::insertLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-char-append!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::appendLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-char-remove!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::removeLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-char-occurrences", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::occurrencesLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-char-ref", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::refLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-char-rank", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::rankLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-char-+", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::unionLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-char-^", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::intersectionLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-char--", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::differenceLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-char-subset", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::subsetLinkCollection);
	STk_add_new_cpp_primitive("Collection-Set-char-proper-subset", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::properSubsetLinkCollection);
	STk_add_new_cpp_primitive("list->mset-Set-char", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::stkList2LinkMSet);
	STk_add_new_cpp_primitive("list->set-Set-char", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::stkList2LinkSet);
	STk_add_new_cpp_primitive("list->sequence-Set-char", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::stkList2LinkSequence);
	STk_add_new_cpp_primitive("mset-Set-char->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::collection2STkList);
	STk_add_new_cpp_primitive("set-Set-char->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::collection2STkList);
	STk_add_new_cpp_primitive("sequence-Set-char->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::collection2STkList);
	STk_add_new_cpp_primitive("mset-Set-char->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::collection2STkString);
	STk_add_new_cpp_primitive("set-Set-char->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::collection2STkString);
	STk_add_new_cpp_primitive("sequence-Set-char->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Set_char__>::collection2STkString);

	addListMethod("mset-Set-char",
		"mset-Set-char1", LINK_NEW);
	addListMethod("set-Set-char",
		"set-Set-char1", LINK_NEW);
	addListMethod("sequence-Set-char",
		"sequence-Set-char1", LINK_NEW);
	addOneArgMethod("null?",
		Wrapper<_Collection_Set_char___ >::name, 
		"Collection-Set-char-null?", LINK_OVL);
	addOneArgMethod("size",
		Wrapper<_Collection_Set_char___ >::name, 
		"Collection-Set-char-size", LINK_NEW);
	addTwoArgMethod("eqv?",
		Wrapper<_Collection_Set_char___ >::name, 
		Wrapper<_Collection_Set_char___ >::name, 
		"Collection-Set-char-eqv?", LINK_OVL);
	addBooleanMethod("<",
		Wrapper<_Collection_Set_char___ >::name, 
		"Collection-Set-char-<", LINK_OVL);
	addBooleanMethod("<=",
		Wrapper<_Collection_Set_char___ >::name, 
		"Collection-Set-char-<=", LINK_OVL);
	addBooleanMethod(">",
		Wrapper<_Collection_Set_char___ >::name, 
		"Collection-Set-char->", LINK_OVL);
	addBooleanMethod(">=",
		Wrapper<_Collection_Set_char___ >::name, 
		"Collection-Set-char->=", LINK_OVL);
	addTwoArgMethod("member",
		Wrapper<_Set_char__ >::name, 
		Wrapper<_Collection_Set_char___ >::name, 
		"Collection-Set-char-member", LINK_OVL);
	addTwoArgMethod("ref",
		Wrapper<_Collection_Set_char___ >::name, 
		"<integer>",
		"Collection-Set-char-ref", LINK_NEW);
	addOneArgMethod("clear!",
		Wrapper<_Collection_Set_char___ >::name, 
		"Collection-Set-char-clear!", LINK_NEW);
	addTwoArgMethod("insert!",
		Wrapper<_Set_char__ >::name, 
		Wrapper<_Collection_Set_char___ >::name, 
		"Collection-Set-char-insert!", LINK_NEW);
	addTwoArgMethod("append!",
		Wrapper<_Set_char__ >::name, 
		Wrapper<_Collection_Set_char___ >::name, 
		"Collection-Set-char-append!", LINK_NEW);
	addTwoArgMethod("remove!",
		Wrapper<_Set_char__ >::name, 
		Wrapper<_Collection_Set_char___ >::name, 
		"Collection-Set-char-remove!", LINK_NEW);
	addArbMethod("+",
		Wrapper<_Collection_Set_char___ >::name, 
		"Collection-Set-char-+", LINK_OVL);
	addArbMethod("^",
		Wrapper<_Collection_Set_char___ >::name, 
		"Collection-Set-char-^", LINK_NEW);
	addArbMethod("-",
		Wrapper<_Collection_Set_char___ >::name, 
		"Collection-Set-char--", LINK_OVL);
	genExtra_Collection_Set_char___Methods();
	return UNDEFINED;
}
